/********************************************************************************
* Copyright (c) Erik Kunze 1996 - 1999
*
* Permission to use, distribute, and sell this software and its documentation
* for any purpose is hereby granted without fee, provided that the above
* copyright notice appear in all copies and that both that copyright notice and
* this permission notice appear in supporting documentation, and that the name
* of the copyright holder not be used in advertising or publicity pertaining to
* distribution of the software without specific, written prior permission.  The
* copyright holder makes no representations about the suitability of this
* software for any purpose.  It is provided "as is" without express or implied
* warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
*
* THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
* EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
* PERFORMANCE OF THIS SOFTWARE.
*
* Author: Erik Kunze
*******************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifndef lint
static char rcsid[] = "$Id: scrdump.c,v 1.1 1999/04/01 16:43:55 erik Rel $";
#endif
#include <stdio.h>
#include "mem.h"
#include "io.h"
#include "util.h"
#include "screen.h"
#include "scrdump.h"
int
WriteScreenDump(char *fname)
{
FILE *ofp;
if (!(ofp = Fopen(fname, "wb")))
{
Msg(M_PERR, "couldn't open <%s> for writing", fname);
return -1;
}
if (fwrite(RealMemory[ScreenSelect], 1, (size_t)(PIXEL_LENGTH + ATTR_LENGTH),
ofp) != (size_t)(PIXEL_LENGTH + ATTR_LENGTH))
{
Msg(M_PERR, "couldn't write screen dump");
(void)fclose(ofp);
return -1;
}
(void)fclose(ofp);
return 0;
}
